#!/usr/bin/env python
# Copyright (c) 2002,2003 by Intevation GmbH
# Authors:
# Frank Koormann <frank.koormann@intevation.de>
#
# This program is free software under the GPL (>=v2)
# Read the file COPYING for details.

version__ = "$Revision: 1.2 $"
# $Source: /greaterrepository/greater-pre-processing/insert-disch_att.py,v $
# $Id: insert-disch_att.py,v 1.2 2003/05/20 09:34:04 frank Exp $

import os
import sys

from string import atof

def usage(name):
    """Print usage information."""

    print "USAGE: %s [discharge attribute table] [catchment id]" % name
    print
 
def convert_disch( fname, catch_id ):
    """Convert GREAT-ER I disch.att to GREAT-ER II DISCH_TAB insert statements.
    """

    try:
        disch_att = open(fname, 'r').readlines()
    except:
        print "Error: Could not find or open file '" + fname + "'"
        usage(sys.argv[0])
        return 1
    else:
        print "SPOOL %s-insert_disch.log" % fname
        for line in disch_att:
            if line[0] == '#':
                continue
            d = line.split(',')
            name = d[12].rstrip().replace("'","''")
            print ("INSERT INTO disch_tab VALUES (%s, %s, %s, %s, \
             '%s', '%e', '%e', '%e', '%s', '%e', '%e', '%e', '%e', '%s', '%s');"
                    % (d[0], d[1], catch_id, d[10], name,
                        atof(d[3]), atof(d[4]), atof(d[8]), "0", 
                        atof(d[5]), atof(d[6]), atof(d[7]), atof(d[9]), "", "")
                  )
        print "COMMIT;"
        print "SPOOL OFF"

if __name__ == '__main__':
    import sys

    if len(sys.argv) == 3:
        convert_disch(sys.argv[1], sys.argv[2])
    else:
        usage(sys.argv[0])
