# Copyright (c) 2003 by Intevation GmbH
# Authors:
# Jan-Oliver Wagner <jan@intevation.de>
#
# This program is free software under the GPL (>=v2)
# Read the file COPYING for details.

version__ = "$Revision: 1.1 $"
# $Source: /greaterrepository/greater-pre-processing/support.py,v $
# $Id: support.py,v 1.1 2003/05/20 13:43:38 jan Exp $

def check_for_circle(table):
    """check the topology given by the table for circles.

    table -- a list of 6-tupels describing:
             strechid(0), type(1), up1(2), up2(3), down1(4), down2(5)

    Return 0 if no circle is found, else a list containing the sequence
    where the circle appears.
    Return None if the table has not the right structure.
    """

    dict = {}
    for stretch in table:
        if len(stretch) != 6:
            return None
        dict[stretch[0]] = stretch

    # for all sources and bifircations run downstream and log the visited
    # stretches. If you visit one a second time, there is
    # a circle.
    for stretch in table:
        visited = []
        if (stretch[2] == 0 and stretch[3] == 0) or stretch[1] == -2:
            if stretch[1] == -2:
                visited.append(stretch[2])
                s = dict[stretch[3]]
            else:
                s = stretch
            while s[4] != 0:
                if s[0] in visited:
                    # circle!
                    visited.append(s[0])
                    while visited[0] != s[0]:
                        visited.pop(0)
                    return visited
                visited.append(s[0])
                s = dict[s[4]]
            visited.append(s[0])
            
    return 0
